# Poco

# template < typename ch, typename tr, typename ba = BufferAllocator < ch >>

# class BasicBufferedStreamBuf

Library: Foundation
Package: Streams
Header: Poco/BufferedStreamBuf.h

## Description

This is an implementation of a buffered streambuf that greatly simplifies the implementation of custom streambufs of various kinds. Derived classes only have to override the methods readFromDevice() or writeToDevice().

This streambuf only supports unidirectional streams. In other words, the BasicBufferedStreamBuf can be used for the implementation of an istream or an ostream, but not for an iostream.

## Inheritance

Direct Base Classes: std::basic_streambuf < ch, tr >

All Base Classes: std::basic_streambuf < ch, tr >

## Member Summary

Member Functions: getMode, overflow, setMode, sync, underflow

## Types

### Allocator

typedef ba Allocator;

### Base

typedef std::basic_streambuf < ch, tr > Base;

### IOS

typedef std::basic_ios < ch, tr > IOS;

### char_traits

typedef tr char_traits;

### char_type

typedef ch char_type;

### int_type

typedef typename Base::int_type int_type;

### off_type

typedef typename Base::off_type off_type;

### openmode

typedef typename IOS::openmode openmode;

### pos_type

typedef typename Base::pos_type pos_type;

## Constructors

### BasicBufferedStreamBuf

BasicBufferedStreamBuf(
std::streamsize bufferSize,
openmode mode
);

## Destructor

### ~BasicBufferedStreamBuf

~BasicBufferedStreamBuf();

## Member Functions

### overflow

virtual int_type overflow(
int_type c
);

### sync

virtual int sync();

### underflow

virtual int_type underflow();

### getMode

openmode getMode() const;

### setMode

void setMode(
openmode mode
);